/*
 * This file was generated automatically by xsubpp version 1.9508 from the
 * contents of GMainLoop.xs. Do not edit this file, edit GMainLoop.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "GMainLoop.xs"
/*
 * Copyright (C) 2003-2005 by the gtk2-perl team (see the file AUTHORS for
 * the full list)
 *
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2.1 of the License, or (at your
 * option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library General Public
 * License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this library; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307  USA.
 *
 * $Header: /cvsroot/gtk2-perl/gtk2-perl-xs/Glib/GMainLoop.xs,v 1.21 2006/08/07 18:17:18 kaffeetisch Exp $
 */

#include "gperl.h"

/* stuff from gmain.h, the main loop and friends */
/*

GMainLoop is in libglib; GClosure is in libgobject.  the mainloop can't refer
to GClosure for dependency reasons, but the code is designed to be used with
GClosure anyway.  that's what we'll do here.

specifically, GSourceDummyMarshal is just a placeholder for GClosureMarshal.

since we have GClosure implemented in GClosure.xs, we'll use it to handle
the callbacks here.


in the more general sense, this file offers the GLib-level interface to the
main loop stuff wrapped by the Gtk2 module.  at the current point, i can't
think of any reason to expose the lower-level main loop stuff here, because
how many apps are going to be using the event loop without Gtk?  then again,
it's quite conceivable that you'd want to do that, so it's not precluded
(just not done).

if you want to implement the main loop stuff here, you'll need to create
typemaps for these types:

	GMainContext	<- Opaque
	GMainLoop	<- Opaque

and you'll need to typemap these if you want to create custom sources
from perl:

	GSource
	GSourceCallbackFuncs
	GSourceFuncs

as far as i can tell, each of these is a ref-counted object, but none
are GObject or GBoxed descendents (as they are part of glib, not gobject!).


for anyone who needs to implement this stuff, i've left the majority
of gmain.h in here, commented out.

*/


/*
 * Since 5.7.3, perl uses "safe" signal handling by default.
 * (As gtk2-perl requires at least 5.8.0, this is relevant to us.)
 * To protect the interpreter from having signal handlers run during
 * important and otherwise uninterruptible operations, when something
 * is installed in %SIG, perl installs a sigaction handler that simply
 * sets a flag saying that a signal is pending; then, at "strategic"
 * points in later operation, it checks that flag.  This is done using
 * the PERL_ASYNC_CHECK() macro after each op.
 *
 * This is important, because while a glib main loop is running, it generally
 * sleeps in a poll(), and control does not normally return to perl.  That
 * causes pending signals to pile up, and looks to the user as though the
 * signals are being ignored.
 *
 * To solve this, the bindings will always install an event source which
 * watches PL_sig_pending, and calls the PERL_ASYNC_CHECK() macro whenever
 * we see it go true.  Since an async signal will wake up a poll(), this
 * will always run at just the right time, so no delays or other performance
 * penalties result.
 *
 * Thanks to Jan Hudec for the implementation idea:
 * http://mail.gnome.org/archives/gtk-perl-list/2004-December/msg00034.html
 */

static gboolean
async_watcher_prepare (GSource * source,
		       gint * timeout)
{
	PERL_UNUSED_VAR (source);
	/* wait as long as you like.  we rely on the fact that the
	 * poll will be awoken by the receipt of an async signal. */
	*timeout = -1;
	return FALSE;
}
static gboolean
async_watcher_check (GSource * source)
{
	PERL_UNUSED_VAR (source);
	return PL_sig_pending;
}
static gboolean
async_watcher_dispatch (GSource     * source,
                        GSourceFunc   callback,
                        gpointer      user_data)
{
	PERL_UNUSED_VAR (source);
	PERL_UNUSED_VAR (callback);
	PERL_UNUSED_VAR (user_data);
	/* this checks PL_sig_pending again, but that's probably not
	 * a bad thing -- it's conceivable that since the check, some
	 * other handler has triggered a perl callback, which would've
	 * cause perl to dispatch the signal handlers, and if we didn't
	 * recheck here we'd redispatch. */
	PERL_ASYNC_CHECK ();
	return TRUE;
}
static void
async_watcher_install (void)
{
	static GSourceFuncs async_watcher_funcs = {
		async_watcher_prepare,
		async_watcher_check,
		async_watcher_dispatch,
		NULL
	};
	/* FIXME: we never unref the watcher. */
	GSource * async_watcher =
		g_source_new (&async_watcher_funcs, sizeof (GSource));
	g_source_attach (async_watcher, NULL);
}


#line 150 "GMainLoop.c"
#if GLIB_CHECK_VERSION(2,4,0)
#define XSubPPtmpAAAA 1


XS(XS_Glib_main_depth); /* prototype to pass -Wmissing-prototypes */
XS(XS_Glib_main_depth)
{
    dXSARGS;
    if (items != 0)
	Perl_croak(aTHX_ "Usage: Glib::main_depth()");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = g_main_depth();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#endif

XS(XS_Glib__MainContext_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_Glib__MainContext_new)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Glib::MainContext::new(class)");
    {
	GMainContext *	RETVAL;

	RETVAL = g_main_context_new(/*void*/);
	ST(0) = sv_newmortal();
	sv_setref_pv (ST(0), "Glib::MainContext", RETVAL);
	g_main_context_ref (RETVAL);
#line 201 "GMainLoop.xs"
	g_main_context_unref (RETVAL); /* release the typemap's ref, so the 
	                                  wrapper owns the object */
#line 189 "GMainLoop.c"
    }
    XSRETURN(1);
}


XS(XS_Glib__MainContext_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Glib__MainContext_DESTROY)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Glib::MainContext::DESTROY(maincontext)");
    {
	GMainContext *	maincontext;

	if (!ST(0) || !SvOK (ST(0)) || !SvROK (ST(0))) {
		maincontext = NULL;
	} else {
		maincontext = INT2PTR (GMainContext *, SvIV (SvRV (ST(0))));
	};
#line 208 "GMainLoop.xs"
	g_main_context_unref (maincontext);
#line 211 "GMainLoop.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Glib__MainContext_default); /* prototype to pass -Wmissing-prototypes */
XS(XS_Glib__MainContext_default)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Glib::MainContext::default(class)");
    {
	GMainContext *	RETVAL;

	RETVAL = g_main_context_default(/*void*/);
	ST(0) = sv_newmortal();
	sv_setref_pv (ST(0), "Glib::MainContext", RETVAL);
	g_main_context_ref (RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Glib__MainContext_iteration); /* prototype to pass -Wmissing-prototypes */
XS(XS_Glib__MainContext_iteration)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Glib::MainContext::iteration(context, may_block)");
    {
	gboolean	RETVAL;
	GMainContext *	context;
	gboolean	may_block = (bool)SvTRUE(ST(1));

	if (!ST(0) || !SvOK (ST(0)) || !SvROK (ST(0))) {
		context = NULL;
	} else {
		context = INT2PTR (GMainContext *, SvIV (SvRV (ST(0))));
	};

	RETVAL = g_main_context_iteration(context, may_block);
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Glib__MainContext_pending); /* prototype to pass -Wmissing-prototypes */
XS(XS_Glib__MainContext_pending)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Glib::MainContext::pending(context)");
    {
	gboolean	RETVAL;
	GMainContext *	context;

	if (!ST(0) || !SvOK (ST(0)) || !SvROK (ST(0))) {
		context = NULL;
	} else {
		context = INT2PTR (GMainContext *, SvIV (SvRV (ST(0))));
	};

	RETVAL = g_main_context_pending(context);
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Glib__MainLoop_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_Glib__MainLoop_new)
{
    dXSARGS;
    if (items < 1 || items > 3)
	Perl_croak(aTHX_ "Usage: Glib::MainLoop::new(class, context=NULL, is_running=FALSE)");
    {
	GMainContext *	context;
	gboolean	is_running;
	GMainLoop *	RETVAL;

	if (items < 2)
	    context = NULL;
	else {
	    if (!ST(1) || !SvOK (ST(1)) || !SvROK (ST(1))) {
		    context = NULL;
	    } else {
		    context = INT2PTR (GMainContext *, SvIV (SvRV (ST(1))));
	    };
	}

	if (items < 3)
	    is_running = FALSE;
	else {
	    is_running = (bool)SvTRUE(ST(2));
	}

	RETVAL = g_main_loop_new(context, is_running);
	ST(0) = sv_newmortal();
	sv_setref_pv (ST(0), "Glib::MainLoop", RETVAL);
	g_main_loop_ref (RETVAL);

#line 286 "GMainLoop.xs"
	g_main_loop_unref (RETVAL);
#line 318 "GMainLoop.c"
    }
    XSRETURN(1);
}


XS(XS_Glib__MainLoop_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Glib__MainLoop_DESTROY)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Glib::MainLoop::DESTROY(mainloop)");
    {
	GMainLoop *	mainloop = INT2PTR (GMainLoop *, SvIV (SvRV (ST(0))));
#line 292 "GMainLoop.xs"
	g_main_loop_unref (mainloop);
#line 334 "GMainLoop.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Glib__MainLoop_run); /* prototype to pass -Wmissing-prototypes */
XS(XS_Glib__MainLoop_run)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Glib::MainLoop::run(loop)");
    {
	GMainLoop *	loop = INT2PTR (GMainLoop *, SvIV (SvRV (ST(0))));

	g_main_loop_run(loop);
    }
    XSRETURN_EMPTY;
}


XS(XS_Glib__MainLoop_quit); /* prototype to pass -Wmissing-prototypes */
XS(XS_Glib__MainLoop_quit)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Glib::MainLoop::quit(loop)");
    {
	GMainLoop *	loop = INT2PTR (GMainLoop *, SvIV (SvRV (ST(0))));

	g_main_loop_quit(loop);
    }
    XSRETURN_EMPTY;
}


XS(XS_Glib__MainLoop_is_running); /* prototype to pass -Wmissing-prototypes */
XS(XS_Glib__MainLoop_is_running)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Glib::MainLoop::is_running(loop)");
    {
	gboolean	RETVAL;
	GMainLoop *	loop = INT2PTR (GMainLoop *, SvIV (SvRV (ST(0))));

	RETVAL = g_main_loop_is_running(loop);
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Glib__MainLoop_get_context); /* prototype to pass -Wmissing-prototypes */
XS(XS_Glib__MainLoop_get_context)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Glib::MainLoop::get_context(loop)");
    {
	GMainContext *	RETVAL;
	GMainLoop *	loop = INT2PTR (GMainLoop *, SvIV (SvRV (ST(0))));

	RETVAL = g_main_loop_get_context(loop);
	ST(0) = sv_newmortal();
	sv_setref_pv (ST(0), "Glib::MainContext", RETVAL);
	g_main_context_ref (RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Glib__Source_remove); /* prototype to pass -Wmissing-prototypes */
XS(XS_Glib__Source_remove)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Glib::Source::remove(class, tag)");
    {
	guint	tag = (guint)SvUV(ST(1));
	gboolean	RETVAL;

	RETVAL = g_source_remove(tag);
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Glib__Timeout_add); /* prototype to pass -Wmissing-prototypes */
XS(XS_Glib__Timeout_add)
{
    dXSARGS;
    if (items < 3 || items > 5)
	Perl_croak(aTHX_ "Usage: Glib::Timeout::add(class, interval, callback, data=NULL, priority=G_PRIORITY_DEFAULT)");
    {
	guint	interval = (guint)SvUV(ST(1));
	SV *	callback = ST(2);
	SV *	data;
	gint	priority;
#line 422 "GMainLoop.xs"
	GClosure * closure;
	GSource * source;
#line 439 "GMainLoop.c"
	guint	RETVAL;
	dXSTARG;

	if (items < 4)
	    data = NULL;
	else {
	    data = ST(3);
	}

	if (items < 5)
	    priority = G_PRIORITY_DEFAULT;
	else {
	    priority = (gint)SvIV(ST(4));
	}
#line 425 "GMainLoop.xs"
	closure = gperl_closure_new (callback, data, FALSE);
	source = g_timeout_source_new (interval);
	if (priority != G_PRIORITY_DEFAULT)
		g_source_set_priority (source, priority);
	g_source_set_closure (source, closure);
	RETVAL = g_source_attach (source, NULL);
	g_source_unref (source);
#line 462 "GMainLoop.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Glib__Idle_add); /* prototype to pass -Wmissing-prototypes */
XS(XS_Glib__Idle_add)
{
    dXSARGS;
    if (items < 2 || items > 4)
	Perl_croak(aTHX_ "Usage: Glib::Idle::add(class, callback, data=NULL, priority=G_PRIORITY_DEFAULT_IDLE)");
    {
	SV *	callback = ST(1);
	SV *	data;
	gint	priority;
#line 457 "GMainLoop.xs"
	GClosure * closure;
	GSource * source;
#line 482 "GMainLoop.c"
	guint	RETVAL;
	dXSTARG;

	if (items < 3)
	    data = NULL;
	else {
	    data = ST(2);
	}

	if (items < 4)
	    priority = G_PRIORITY_DEFAULT_IDLE;
	else {
	    priority = (gint)SvIV(ST(3));
	}
#line 460 "GMainLoop.xs"
	closure = gperl_closure_new (callback, data, FALSE);
	source = g_idle_source_new ();
	g_source_set_priority (source, priority);
	g_source_set_closure (source, closure);
	RETVAL = g_source_attach (source, NULL);
	g_source_unref (source);
#line 504 "GMainLoop.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Glib__IO_add_watch); /* prototype to pass -Wmissing-prototypes */
XS(XS_Glib__IO_add_watch)
{
    dXSARGS;
    if (items < 4 || items > 6)
	Perl_croak(aTHX_ "Usage: Glib::IO::add_watch(class, fd, condition, callback, data=NULL, priority=G_PRIORITY_DEFAULT)");
    {
	int	fd = (int)SvIV(ST(1));
	GIOCondition	condition = gperl_convert_flags (G_TYPE_IO_CONDITION, ST(2));
	SV *	callback = ST(3);
	SV *	data;
	gint	priority;
#line 507 "GMainLoop.xs"
	GClosure * closure;
	GSource * source;
	GIOChannel * channel;
#line 527 "GMainLoop.c"
	guint	RETVAL;
	dXSTARG;

	if (items < 5)
	    data = NULL;
	else {
	    data = ST(4);
	}

	if (items < 6)
	    priority = G_PRIORITY_DEFAULT;
	else {
	    priority = (gint)SvIV(ST(5));
	}
#line 511 "GMainLoop.xs"
#ifdef USE_SOCKETS_AS_HANDLES
        /* native win32 doesn't have fd's, so first convert perls fd into a winsock fd */
        channel = g_io_channel_win32_new_socket ((HANDLE)win32_get_osfhandle (fd));
#else
        channel = g_io_channel_unix_new (fd);
#endif  /* USE_SOCKETS_AS_HANDLES */
	source = g_io_create_watch (channel, condition);
	if (priority != G_PRIORITY_DEFAULT)
		g_source_set_priority (source, priority);
	closure = gperl_closure_new (callback, data, FALSE);
	g_source_set_closure (source, closure);
	RETVAL = g_source_attach (source, NULL);
	g_source_unref (source);
	g_io_channel_unref (channel);
#line 557 "GMainLoop.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Glib__MainLoop); /* prototype to pass -Wmissing-prototypes */
XS(boot_Glib__MainLoop)
{
    dXSARGS;
    char* file = __FILE__;

    XS_VERSION_BOOTCHECK ;

#if XSubPPtmpAAAA
        newXS("Glib::main_depth", XS_Glib_main_depth, file);
#endif
        newXS("Glib::MainContext::new", XS_Glib__MainContext_new, file);
        newXS("Glib::MainContext::DESTROY", XS_Glib__MainContext_DESTROY, file);
        newXS("Glib::MainContext::default", XS_Glib__MainContext_default, file);
        newXS("Glib::MainContext::iteration", XS_Glib__MainContext_iteration, file);
        newXS("Glib::MainContext::pending", XS_Glib__MainContext_pending, file);
        newXS("Glib::MainLoop::new", XS_Glib__MainLoop_new, file);
        newXS("Glib::MainLoop::DESTROY", XS_Glib__MainLoop_DESTROY, file);
        newXS("Glib::MainLoop::run", XS_Glib__MainLoop_run, file);
        newXS("Glib::MainLoop::quit", XS_Glib__MainLoop_quit, file);
        newXS("Glib::MainLoop::is_running", XS_Glib__MainLoop_is_running, file);
        newXS("Glib::MainLoop::get_context", XS_Glib__MainLoop_get_context, file);
        newXS("Glib::Source::remove", XS_Glib__Source_remove, file);
        newXS("Glib::Timeout::add", XS_Glib__Timeout_add, file);
        newXS("Glib::Idle::add", XS_Glib__Idle_add, file);
        newXS("Glib::IO::add_watch", XS_Glib__IO_add_watch, file);

    /* Initialisation Section */

#line 143 "GMainLoop.xs"
	async_watcher_install ();

#if XSubPPtmpAAAA
#endif
#line 479 "GMainLoop.xs"
	gperl_register_fundamental (G_TYPE_IO_CONDITION, "Glib::IOCondition");

#line 603 "GMainLoop.c"

    /* End of Initialisation Section */

    XSRETURN_YES;
}

